My Project: NewtonUserJoint Class Reference

My Project

Public Member Functions | List of all members
NewtonUserJoint Class Reference

`#include <NewtonClass.h>`

Inheritance diagram for NewtonUserJoint:

## Public Member Functions

| NewtonUserJoint (dgWorld *const world, dgInt32 maxDof, NewtonUserBilateralCallback callback, NewtonUserBilateralGetInfoCallback getInfo, dgBody *const dyn0, dgBody *const dyn1)
| ~NewtonUserJoint ()
dgUnsigned32 | JacobianDerivative (dgContraintDescritor &params)
void | AddAngularRowJacobian (const dgVector &dir, dgFloat32 relAngle)
void | AddGeneralRowJacobian (const dgFloat32 *const jacobian0, const dgFloat32 *const jacobian1)
void | AddLinearRowJacobian (const dgVector &pivot0, const dgVector &pivot1, const dgVector &dir)
dgFloat32 | GetRowForce (dgInt32 row) const
void | SetHighFriction (dgFloat32 friction)
void | SetLowerFriction (dgFloat32 friction)
void | SetRowStiffness (dgFloat32 stiffness)
void | SetAcceleration (dgFloat32 acceleration)
void | SetSpringDamperAcceleration (dgFloat32 springK, dgFloat32 springD)
void | GetInfo (dgConstraintInfo *const info) const
void | SetUpdateFeedbackFunction (NewtonUserBilateralCallback getFeedback)
void | SetMaxContactsForExactSolver (bool mode, dgInt32 MaxCount)
Public Member Functions inherited from dgBilateralConstraint
virtual void | SetDestructorCallback (OnConstraintDestroy destructor)
Public Member Functions inherited from dgConstraint
dgUnsigned32 | GetId () const
dgBody * | GetBody0 () const
dgBody * | GetBody1 () const
void | SetBodies (dgBody *const body0, dgBody *const body1)
dgBodyMasterListRow::dgListNode * | GetLink0 () const
dgBodyMasterListRow::dgListNode * | GetLink1 () const
void * | GetUserData () const
bool | IsActive () const
bool | IsCollidable () const
virtual void | ResetMaxDOF ()
dgInt32 | GetMaxDOF () const
void | SetUserData (void *userData)
void | SetCollidable (bool state)

## Additional Inherited Members

Public Types inherited from dgConstraint
enum | dgConstraintID { m_ballConstraint, m_hingeConstraint, m_sliderConstraint, m_contactConstraint, m_upVectorConstraint, m_universalConstraint, m_corkScrewConstraint, m_unknownConstraint }
Protected Member Functions inherited from dgUserConstraint
| dgUserConstraint (dgWorld *const manager, dgBody *const dyn0, dgBody *const dyn1, dgInt32 constraintID)
virtual | ~dgUserConstraint ()
Protected Member Functions inherited from dgBilateralConstraint
| dgBilateralConstraint ()
virtual | ~dgBilateralConstraint ()
virtual void | Init ()
virtual void | Remove (dgWorld *world)
virtual bool | IsBilateral () const
virtual dgFloat32 | GetStiffness () const
virtual void | SetStiffness (dgFloat32 stiffness)
void | SetPivotAndPinDir (const dgVector &pivot, const dgVector &pinDirection)
void | SetPivotAndPinDir (const dgVector &pivot, const dgVector &pinDirection0, const dgVector &pinDirection1)
dgVector | CalculateGlobalMatrixAndAngle (dgMatrix &globalMatrix0, dgMatrix &globalMatrix1) const
void | CalculateMatrixOffset (const dgVector &pivot, const dgVector &dir, dgMatrix &matrix0, dgMatrix &matrix1)
virtual void | JointAccelerations (dgJointAccelerationDecriptor *const params)
virtual void | JointVelocityCorrection (dgJointAccelerationDecriptor *const params)
void | SetMotorAcceleration (dgInt32 index, dgFloat32 accelration, dgContraintDescritor &desc)
void | SetJacobianDerivative (dgInt32 index, dgContraintDescritor &desc, const dgFloat32 *const jacobianA, const dgFloat32 *const jacobianB, dgForceImpactPair *const jointForce)
void | CalculatePointDerivative (dgInt32 index, dgContraintDescritor &desc, const dgVector &normalGlobal, const dgPointParam &param, dgForceImpactPair *const jointForce)
void | CalculateAngularDerivative (dgInt32 index, dgContraintDescritor &desc, const dgVector &normalGlobal, dgFloat32 stiffness, dgFloat32 jointAngle, dgForceImpactPair *const jointForce)
dgFloat32 | CalculateSpringDamperAcceleration (dgInt32 index, const dgContraintDescritor &desc, dgFloat32 jointAngle, const dgVector &p0Global, const dgVector &p1Global, dgFloat32 springK, dgFloat32 springD)
void | SetMaxContactsForExactSolver (bool mode, dgInt32 MaxCount)
Protected Member Functions inherited from dgConstraint
| dgConstraint ()
virtual | ~dgConstraint ()
void | SetUpdateFeedbackFunction (ConstraintsForceFeeback function)
void | InitPointParam (dgPointParam &param, dgFloat32 stiffness, const dgVector &p0Global, const dgVector &p1Global) const
void | InitInfo (dgConstraintInfo *const info) const
Protected Attributes inherited from dgBilateralConstraint
dgMatrix | m_localMatrix0
dgMatrix | m_localMatrix1
dgFloat32 | m_stiffness
dgForceImpactPair | m_jointForce [DG_BILATERAL_CONTRAINT_DOF]
dgInt32 | m_rowIsMotor [DG_BILATERAL_CONTRAINT_DOF]
dgFloat32 | m_motorAcceleration [DG_BILATERAL_CONTRAINT_DOF]
dgInt32 | m_useExactSolverContactLimit
OnConstraintDestroy | m_destructor
Protected Attributes inherited from dgConstraint
void * | m_userData
dgBody * | m_body0
dgBody * | m_body1
dgBodyMasterListRow::dgListNode * | m_link0
dgBodyMasterListRow::dgListNode * | m_link1
ConstraintsForceFeeback | m_updaFeedbackCallback
dgUnsigned32 | m_dynamicsLru
dgUnsigned32 | m_index
dgUnsigned32 | m_maxDOF: 6
dgUnsigned32 | m_constId: 6
dgUnsigned32 | m_enableCollision: 1
dgUnsigned32 | m_useExactSolver: 1
dgUnsigned32 | m_solverActive: 1
dgUnsigned32 | m_contactActive: 1

## Constructor & Destructor Documentation

## § NewtonUserJoint()

NewtonUserJoint::NewtonUserJoint | ( | dgWorld *const | world,
|  | dgInt32 | maxDof,
|  | NewtonUserBilateralCallback | callback,
|  | NewtonUserBilateralGetInfoCallback | getInfo,
|  | dgBody *const | dyn0,
|  | dgBody *const | dyn1
| ) |  |

## § ~NewtonUserJoint()

NewtonUserJoint::~NewtonUserJoint | ( |  | ) |

## Member Function Documentation

## § AddAngularRowJacobian()

void NewtonUserJoint::AddAngularRowJacobian | ( | const dgVector & | dir,
|  | dgFloat32 | relAngle
| ) |  |

## § AddGeneralRowJacobian()

void NewtonUserJoint::AddGeneralRowJacobian | ( | const dgFloat32 *const | jacobian0,
|  | const dgFloat32 *const | jacobian1
| ) |  |

## § AddLinearRowJacobian()

void NewtonUserJoint::AddLinearRowJacobian | ( | const dgVector & | pivot0,
|  | const dgVector & | pivot1,
|  | const dgVector & | dir
| ) |  |

## § GetInfo()

void NewtonUserJoint::GetInfo | ( | dgConstraintInfo *const | info | ) | const

virtual

Reimplemented from dgUserConstraint.

## § GetRowForce()

dgFloat32 NewtonUserJoint::GetRowForce | ( | dgInt32 | row | ) | const

## § JacobianDerivative()

dgUnsigned32 NewtonUserJoint::JacobianDerivative | ( | dgContraintDescritor & | params | ) |

virtual

Implements dgUserConstraint.

## § SetAcceleration()

void NewtonUserJoint::SetAcceleration | ( | dgFloat32 | acceleration | ) |

## § SetHighFriction()

void NewtonUserJoint::SetHighFriction | ( | dgFloat32 | friction | ) |

## § SetLowerFriction()

void NewtonUserJoint::SetLowerFriction | ( | dgFloat32 | friction | ) |

## § SetMaxContactsForExactSolver()

void NewtonUserJoint::SetMaxContactsForExactSolver | ( | bool | mode,
|  | dgInt32 | MaxCount
| ) |  |

## § SetRowStiffness()

void NewtonUserJoint::SetRowStiffness | ( | dgFloat32 | stiffness | ) |

## § SetSpringDamperAcceleration()

void NewtonUserJoint::SetSpringDamperAcceleration | ( | dgFloat32 | springK,
|  | dgFloat32 | springD
| ) |  |

## § SetUpdateFeedbackFunction()

void NewtonUserJoint::SetUpdateFeedbackFunction | ( | NewtonUserBilateralCallback | getFeedback | ) |

The documentation for this class was generated from the following files:

- dynamics.mod/NewtonDynamics/source/newton/NewtonClass.h
- dynamics.mod/NewtonDynamics/source/newton/NewtonClass.cpp